import jp.ac.takushoku_u.cs.*;

/**
* SPTableNX̃eXgpNX
* @version 1.0
* @author } Tj(Kasajima Hiroshi)
*/
/*
* ŏIXV 2005N0108
*/
class SPTableTest{

public static void main(String[] args){

	double[][] sampleData = { //SP\f[^
	
		{1,1,1,1,0,1},
		{1,0,0,1,0,1},
		{1,0,0,1,1,0},
		{1,0,1,1,0,0},
		{1,1,1,1,0,0},
		{1,1,0,0,0,0},
		{1,0,1,0,1,1}};

	//͑Ώۂ̃}gNX𐶐
	ArithmeticMatrix dataMatrix = new ArithmeticMatrix(sampleData);
	
	//}gNXɍsƗ񖼂t
	for(int i = 1; i <= sampleData.length; i++){
		dataMatrix.setRowName(i-1,"k" + i + " ");
	}
	for(int i = 1; i <= sampleData[0].length; i++){
		dataMatrix.setColName(i-1,"" + i + " ");
	}
	
	//SP\쐬s
	SPTable result = new SPTable(dataMatrix);
	
	ArithmeticMatrix outMatrix = new ArithmeticMatrix();
	outMatrix.matrixCopy(result.getBaseSPMatrix());
	System.out.println("̃}gNX");
	outputMatrix(outMatrix);
	
	ArithmeticMatrix outSPMatrix = new ArithmeticMatrix();
	outSPMatrix.matrixCopy(result.getSPMatrix());
	System.out.println("SP}gNX");
	outputMatrix(outSPMatrix);
	
	ArithmeticMatrix outSPFullMatrix = new ArithmeticMatrix();
	outSPFullMatrix.matrixCopy(result.getSPFullMatrix());
	System.out.println("SP}gNX-S");
	outputDoubleMatrix(outSPFullMatrix);
	
	int[] row = new int[sampleData.length];
	int[] col = new int[sampleData[0].length];
	System.arraycopy(result.getSArray(), 0, row, 0, row.length);
	System.arraycopy(result.getPArray(), 0, col, 0, col.length);
	System.out.print("SȐ: ");
	for(int i = 0; i < row.length; i++){
		System.out.print((row[i]) + ", ");
	}
	System.out.println();
	System.out.print("PȐ: ");
	for(int i = 0; i < col.length; i++){
		System.out.print((col[i]) + ", ");
	}
	System.out.println();
	
}
	
/**
* }gNXint^ŕWo͂ɏo͂܂B
* @param outMatrix oׂ͂}gNX
*/
	private static void outputMatrix(ArithmeticMatrix outMatrix){
		System.out.print("            ");
		for(int j = 0; j < outMatrix.getColLength(); j++){		//񖼏o
			System.out.print(outMatrix.getColName(j) + "  ");
		}
		System.out.println();
		for(int i = 0 ; i < outMatrix.getRowLength(); i++){
			if(i < 9){
			System.out.print(outMatrix.getRowName(i) + " ");		//so
			}
			else{
				System.out.print(outMatrix.getRowName(i) + " ");
			}
			for(int j = 0; j < outMatrix.getColLength(); j++){		//vfo
				if(j == (outMatrix.getColLength() - 1)){
					System.out.println("     "+(int)outMatrix.getCell(i, j));
				}
				else{
					System.out.print("     "+(int)outMatrix.getCell(i, j));
				}
			}
		}
		System.out.println();
	}
	
/**
* S-P\̃}gNXdouble^ŕWo͂ɏo͂܂B
* @param outMatrix oׂ͂}gNX
*/
	private static void outputDoubleMatrix(ArithmeticMatrix outMatrix){
		java.text.NumberFormat df = new java.text.DecimalFormat("0.00");		//_ȉ2܂ŏo
		System.out.print("            ");
		for(int j = 0; j < outMatrix.getColLength(); j++){
			System.out.print(outMatrix.getColName(j) + "  ");		//񖼏o
		}
		System.out.println();
		for(int i = 0 ; i < outMatrix.getRowLength(); i++){
			System.out.print(outMatrix.getRowName(i) + "  ");		//so
			if(i < outMatrix.getRowLength() - 4 || i == outMatrix.getRowLength() - 3){
				System.out.print("    ");
			}
			else if(i == outMatrix.getRowLength() - 4 || i == outMatrix.getRowLength() - 2){
				System.out.print("  ");
			}
			for(int j = 0; j < outMatrix.getColLength(); j++){		//vfo
				if(j == (outMatrix.getColLength() - 1)){
					System.out.println(df.format(outMatrix.getCell(i, j)));
				}
				else{
					System.out.print(df.format(outMatrix.getCell(i, j) )+"  ");
				}
			}
		}
		System.out.println();
	}
	
/**
* }gNXString^ŕWo͂ɏo͂܂B
*/
	private static void outputMatrix(StringMatrix outMatrix){
		System.out.print("       ");
		for(int j = 0; j < outMatrix.getColLength(); j++){		//񖼏o
			System.out.print(outMatrix.getColName(j) + " ");
		}
		System.out.println();
		for(int i = 0 ; i < outMatrix.getRowLength(); i++){
			if(i < 9){
			System.out.print(outMatrix.getRowName(i) + " ");		//so
			}
			else{
				System.out.print(outMatrix.getRowName(i) + " ");
			}
			for(int j = 0; j < outMatrix.getColLength(); j++){		//vfo
				if(j == (outMatrix.getColLength() - 1)){
					System.out.println(" "+outMatrix.getCell(i, j));
				}
				else{
					System.out.print(" "+outMatrix.getCell(i, j));
				}
			}
		}
		System.out.println();
	}
}
